/////////////////////////////////
//ESP32 IOT connecté à une carte microbit
// relier P0(Rx) à D4(shield Grove sur une D1R32) à GPIO17(Tx)
// relier P14(Tx) à D5 à GPIO16(Rx)
/////////////////////////////////
#include <WiFi.h>
#include <string.h>
#define RXD2 16
#define TXD2 17


IPAddress ip_gateway(192,168,0,1);
IPAddress ip_subnet(255,255,255,0);

WiFiServer server(2000);
WiFiClient client;

char ip_address_server[20]="";
char port[7]="";
String  reception;
int i;
IPAddress adresse_IP_client_connecte;
String str_adresse_IP_client_connecte;

void setup()
{
  Serial.begin(115200);
  Serial2.begin(115200, SERIAL_8N1, RXD2, TXD2);
  //Serial2.begin(115200);
}

void loop()
{
    if (Serial2.available() > 0) {
      reception = Serial2.readString();
      
      Serial.println(reception);
      Serial.println("length="+String(reception.length()));
      if (reception.indexOf("connect_to_AP") != -1) {
        Serial.println("connect_to_AP");

        char ssid[15]="";
        strncpy(ssid,&reception[14],reception.indexOf(",",14));
        ssid[reception.indexOf(",",14)-14]='\0';

        char password[30]="";
        strncpy(password,&reception[reception.indexOf(",",14)+1],reception.length()-reception.indexOf(",",14)-1);
        password[reception.length()-reception.indexOf(",",14)-1]='\0';
        Serial.println("password="+String(password));
        Serial.println("Demande de connexion au moint d'accès:"+String(ssid)+" mot de passe="+String(password));
        if (WiFi.status() != WL_CONNECTED){
          WiFi.begin(ssid,password);
        }
      }
      else if (reception.indexOf("connected_to_AP?") != -1) {
        Serial.println("connected_to_AP?");
        if (WiFi.status() == WL_CONNECTED) {
          String mot="connected_to_AP";
          Serial2.print(mot+"#");
          Serial.println("ESP32 connecté au point d'accès");
          Serial.print("Actual IP address=");
          Serial.println(WiFi.localIP());
        }
      }
      else if (reception.indexOf("Connect_to_server") != -1) {
        Serial.println("Connect_to_server");
        WiFiClient client;
        strncpy(ip_address_server,&reception[18],reception.indexOf(",",18));
        ip_address_server[reception.indexOf(",",18)-18]='\0';

        
        strncpy(port,&reception[reception.indexOf(",",18)+1],reception.length()-reception.indexOf(",",18)-1);
        port[reception.length()-reception.indexOf(",",18)-1]='\0';
        Serial.println("Demande de connexion au serveur d'adresse IP="+String(ip_address_server)+" port="+String(port));

        
        if (client.connect(ip_address_server, atoi(port))) {
          String mot="connected_to_server";
          Serial2.print(mot+"#");
          Serial.println("Connecté au serveur");
        }
        else {
          String mot="not_connected_to_server";
          Serial2.print(mot+"#");
        }
      }
      else if (reception.indexOf("Send_to_Server") != -1) {
        WiFiClient client;
        Serial.println("Send_to_Server");
        char data_to_server[30]="";
        strncpy(data_to_server,&reception[15],reception.length()-1);
        data_to_server[reception.length()-15]='\0';
        if (client.connect(ip_address_server, atoi(port))) {
          Serial.println("Envoi au serveur de:"+String(data_to_server));
          client.print(data_to_server);
        }
        
      }
      else if (reception.indexOf("set_IP_address_esp32") != -1) {
        
        char ip1[4]="";
        byte index_p1 = reception.indexOf(".",21);
        strncpy(ip1,&reception[21],index_p1-21);
        ip1[index_p1-21]='\0';
        byte ip1b=byte(String(ip1).toInt());

        
        char ip2[4]="";
        byte index_p2 = reception.indexOf(".", index_p1+1);
        strncpy(ip2,&reception[index_p1+1],index_p2-index_p1-1);
        ip2[index_p2-index_p1]='\0';
        byte ip2b=byte(String(ip2).toInt());


        char ip3[4]="";
        byte index_p3 = reception.indexOf(".", index_p2+1);
        strncpy(ip3,&reception[index_p2+1],index_p3-index_p2-1);
        ip3[index_p3-index_p2]='\0';
        byte ip3b=byte(String(ip3).toInt());

        char ip4[4]="";
        byte index_p4 = reception.length();
        strncpy(ip4,&reception[index_p3+1],index_p4-index_p3-1);
        ip4[index_p4-index_p3]='\0';
        byte ip4b=byte(String(ip4).toInt());
        
        IPAddress ip(ip1b, ip2b, ip3b, ip4b);
        WiFi.config(ip,ip_gateway,ip_subnet);
        Serial.print("New IP address=");
        Serial.print(WiFi.localIP()); 
      }
      
      else if (reception.indexOf("Start_Server") != -1) {
        Serial.println("Start_Server");

        strncpy(port,&reception[14],reception.length()-14);
        port[reception.length()-14]='\0';
        server.begin();//atoi(port));
        Serial.println("Server started");
      }
      
      else if (reception.indexOf("answer_client_request") != -1) {
        Serial.println("answer_client_request");
        char answer_server[30]="";
        strncpy(answer_server,&reception[22],reception.length()-22);
        answer_server[reception.length()-22]='\0';
        if (client.connected()) {
          Serial.print("client connecté");
          //if (client.available()) {
          Serial.print("client connecté"+String(answer_server));
          client.println(String(answer_server));
          Serial.println("Server answer to client ="+String(answer_server));
          //client.flush();
          //Serial.println("client disconnected!");
         // }
        }
      }

      else if (reception.indexOf("IPaddress_client_connected?") != -1) {
        Serial.println("IPaddress_client_connected?");
        Serial.print("IP Client=");

        Serial.println(str_adresse_IP_client_connecte);
        Serial2.print(str_adresse_IP_client_connecte+"#");
      }

      else if (reception.indexOf("answer_server") != -1) {
        WiFiClient client;
        Serial.println("answer_server");
        //wait for the server's reply to become available
        if (client.connect(ip_address_server, atoi(port))) {
          while (!client.available())
          {
            delay(1); //delay 1 msec
          }
          if (client.available() > 0) {
            String donnee_recue_du_serveur = client.readStringUntil('\r');
            Serial.print("Donnée reçue du serveur=");
            Serial.println(donnee_recue_du_serveur);
            Serial2.print(donnee_recue_du_serveur+"#");
          }
        }
      }
        
      else if (reception.indexOf("read_client_request") != -1) {
        Serial.println("read_client_request");
        client = server.available();   
        Serial.println("listening client....!");
        while (!client){ 
          client = server.available();
        }
        Serial.println("client connected!");

        if (client) {                            
          Serial.print("IP Client=");  
          adresse_IP_client_connecte = client.remoteIP();
          str_adresse_IP_client_connecte = String(adresse_IP_client_connecte[0])+"."+String(adresse_IP_client_connecte[1])+"."+String(adresse_IP_client_connecte[2])+"."+String(adresse_IP_client_connecte[3]);    
          Serial.println(str_adresse_IP_client_connecte);
          if (client.connected()) {            
            while(!client.available()){  delay(1); }
            if (client.available()) {
              String ClientRequest = (client.readStringUntil('#'));
              Serial.println("client data received="+ClientRequest);
              Serial2.print(ClientRequest+"#");
            }
        }
        //client.stop();
      }
    }
  }
}
